# buildforkernels macro hint: when you build a new version or a new release
# that contains bugfixes or other improvements then you must disable the
# "buildforkernels newest" macro for just that build; immediately after
# queuing that build enable the macro again for subsequent builds; that way
# a new akmod package will only get build when a new one is actually needed
#%%define buildforkernels newest

%if 0%{?fedora}
%define buildforkernels akmod
%define debug_package %{nil} 
%endif

%global optflags %(echo %{optflags} -fno-pic)

Name:		tp_smapi-kmod
Version:	0.43
Release:	10%{?dist}
Summary:	Kernel module for some Thinkpad hardware/firmware features

%define distname tp_smapi-%{version}

Group:		System Environment/Kernel
License:	GPL
URL:		http://www.thinkwiki.org/wiki/Tp_smapi
Source0:	http://downloads.sourceforge.net/tpctl/%{distname}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%global AkmodsBuildRequires %{_bindir}/kmodtool
BuildRequires:  %{AkmodsBuildRequires}

# needed for plague to make sure it builds for i586 and i686
ExclusiveArch:  i686 x86_64

%{!?kernels:BuildRequires: buildsys-build-rpmfusion-kerneldevpkgs-%{?buildforkernels:%{buildforkernels}}%{!?buildforkernels:current}-%{_target_cpu} }

# kmodtool does its magic here
%{expand:%(kmodtool --target %{_target_cpu} --repo rpmfusion --kmodname %{name} %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null) }

%description
The tp_smapi kernel module exposes some features of the ThinkPad
hardware/firmware via a sysfs interface. Currently, the main implemented
functionality is control of battery charging and extended battery
status. The underlfying hardware interfaces are SMAPI and direct access
to the embedded controller

%prep
#%{?kmodtool_check}

# print kmodtool output for debugging purposes:
kmodtool --target %{_target_cpu}  --repo rpmfusion --kmodname %{name} %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null

%setup -q -c -T -a 0

# Fix permissions
for ext in c h; do
  find . -name "*.$ext" -exec chmod -x '{}' \;
done

for kernel_version in %{?kernel_versions} ; do
  cp -a %{distname} _kmod_build_${kernel_version%%___*}
done

%build
for kernel_version in %{?kernel_versions}; do
  %{__make} %{_smp_mflags} -C _kmod_build_${kernel_version%%___*} KVER="${kernel_version%%___*}" KBUILD="${kernel_version##*___}" HDAPS=1
done

%install
rm -rf ${RPM_BUILD_ROOT}
for kernel_version in %{?kernel_versions}; do
  mkdir -p $RPM_BUILD_ROOT%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}
  pushd _kmod_build_${kernel_version%%___*}
  install -D -m 0755 *.ko $RPM_BUILD_ROOT%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}
  popd
done

%{?akmod_install}

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Fri May 27 2022 Endur <endur@thinkpad.localdomain> - 0.43-10
- added -fno-pic to %optflags

* Sun Apr 03 2022 Andreas Roederer <tlp@warpnine.de> - 0.43-9
- Fedora 36 - Release

* Tue Sep 28 2021 Andreas Roederer <tlp@warpnine.de> - 0.43-8
- Fedora 35 - Release

* Thu Mar 25 2021 Andreas Roederer <tlp@warpnine.de> - 0.43-7
- Fedora 34 - Release

* Wed Oct 28 2020 Andreas Roederer <tlp@warpnine.de> - 0.43-6
- Fedora 33 - Release

* Wed Apr 29 2020 Andreas Roederer <tlp@warpnine.de> - 0.43-5
- Fedora 32 - Release

* Thu Okt 31 2019 Andreas Roederer <tlp@warpnine.de> - 0.43-4
- Fedora 31 - Release

* Fri Apr 26 2019 Andreas Roederer <tlp@warpnine.de> - 0.43-3
- Fedora 30 - Release

* Mon Oct 29 2018 Andreas Roederer <tlp@warpnine.de> - 0.43-2
- Fedora 29 - Release

* Mon Apr 30 2018 Andreas Roederer <tlp@warpnine.de> - 0.43-1
- Fedora 28 - Release

* Sun Feb 18 2018 Andreas Roederer <tlp@warpnine.de> - 0.42-5
- Fedora 27 - Patch für Kernel 4.15+

* Sun Nov 12 2017 Andreas Roederer <tlp@warpnine.de> - 0.42-4
- Fedora 27 - Release

* Fri Jul 14 2017 Andreas Roederer <tlp@warpnine.de> - 0.42-3
- Release for Fedora 26

* Wed Jun 22 2016 Andreas Roederer <tlp@warpnine.de> - 0.42-2
- Release for Fedora 25

* Wed Jun 22 2016 Andreas Roederer <tlp@warpnine.de> - 0.42-1
- tp_smapi 0.42

* Thu May 26 2016 Andreas Roederer <tlp@warpnine.de> - 0.41-8
- Release for Fedora 24

* Wed Nov 04 2015 Andreas Roederer <tlp@warpnine.de> - 0.41-7
- Release for Fedora 23

* Wed Jul 15 2015 Andreas Roederer <tlp@warpnine.de> - 0.41-6
- Release for Fedora 22

* Sun Jan 18 2015 Andreas Roederer <tlp@warpnine.de> - 0.41-5
- Release for Fedora 21

* Fri Dec 20 2013 Andreas Roederer <tlp@warpnine.de> - 0.41-4
- Release for Fedora 20

* Tue Jun 18 2013 Andreas Roederer <tlp@warpnine.de> - 0.41-3
- Release for Fedora 19

* Sun Jan 20 2013 Andreas Roederer <tlp@warpnine.de> - 0.41-2
- spec-file changed for Fedora 18

* Thu May 03 2012 Andreas Roederer <tlp@warpnine.de> - 0.41-1
- Rebuild for Fedora 16

* Mon Nov 21 2011 Matthias Haase <matthias_haase@bennewitz.com> - 0.40-6
- Rebuild for Fedora 16

* Sat May 28 2011 Matthias Haase <matthias_haase@bennewitz.com> - 0.40-5
- Rebuild for Fedora 15

* Mon Jan 17 2011 Matthias Haase <matthias_haase@bennewitz.com> - 0.40-4
- pushd / popd used instead of cd / cd.. on %setup

* Mon Jan 17 2011 Matthias Haase <matthias_haase@bennewitz.com> - 0.40-3
- some clean up done
- %{__make} %{_smp_mflags} is used now instead of make

* Sun Jan 16 2011 Matthias Haase <matthias_haase@bennewitz.com> - 0.40-2
- declare-mutex.patch added to build against kernel >=  2.6.37

* Sun Apr 05 2009 Fabrice Bellet <fabrice@bellet.info> 0.40-1
- Initial package for Fedora
